﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Data;
using System.Globalization;


namespace SilverlightApplication68
{
    public class Person
    {
        string name = string.Empty;
        public string Name
        {
            get { return name; }
            set { name = value; }
        }

        double salary = 0.00;
        public double Salary
        {
            get { return salary; }
            set { salary = value; }
        }

        public string RecommendedRating { get; set; }
    }



    public class RatingProvider : RatingCollection
    {
        public RatingProvider()
        {
            this.AddRange(RatingProvider.SetupEnum());
        }

        private static RatingCollection items;

        private static RatingCollection SetupEnum()
        {
            if (RatingProvider.items == null)
            {
                RatingProvider.items = new RatingCollection();
                items.Add(new Rating { Code = "N/A", Description = "N/A" });
                items.Add(new Rating { Code = "A1", Description = "A1" });
                items.Add(new Rating { Code = "A", Description = "A" });
                items.Add(new Rating { Code = "A2", Description = "A2" });
                items.Add(new Rating { Code = "B1", Description = "B1" });
                items.Add(new Rating { Code = "B2", Description = "B2" });
                items.Add(new Rating { Code = "C", Description = "C" });

            }

            return RatingProvider.items;
        }

    }

    public class RatingCollection : List<Rating>
    {

        public RatingCollection()
        {
        }
    }



    public class Rating
    {


        public Rating()
        {
        }

        public string Code { get; set; }
        public string Description { get; set; }


    }

    public class RatingConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            Rating selectedItem = null;
            RatingProvider values = parameter as RatingProvider;
            if (values != null)
            {
                string selectedValue = (string)value;
                foreach (Rating item in values)
                {
                    if (item.Description == selectedValue)
                    {
                        selectedItem = item;
                        break;
                    }
                }
            }
            return selectedItem;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            string result = string.Empty;

            Rating selectedType = value as Rating;
            if (selectedType != null)
            {
                result = selectedType.Description;
            }

            return result;
        }

    }

}

